> For the complete documentation index, see [llms.txt](https://integration-guide.redeem.gov.sg/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://integration-guide.redeem.gov.sg/phase2-integration/api-documentation/redeeming-a-qr-code-voucher/making-idempotent-redemption-requests/introduction.md).

# Introduction

### 4.2.1 Introduction

For example, if the request to redeem a voucher does not respond due to a connection issue, you can retry the request with the same idempotency key sent in the first request to guarantee that no more than one voucher redemption operation is attempted.

This is **important** as vouchers cannot be logically redeemed twice. Subsequent attempts without idempotency key header to redeem the same voucher will **always** result in a <mark style="color:red;">`HTTP 402`</mark> response with error code, <mark style="color:red;">`redemption_vouchers_used`</mark>, as the voucher has already been redeemed in the prior request.

If subsequent retries are not identified with an idempotency key, disputes on whether the vouchers were successfully redeemed or was already used could occur.

{% hint style="info" %}
It is compulsory for retailers to include idempotency key whenever making a redemption call to RedeemSG API
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://integration-guide.redeem.gov.sg/phase2-integration/api-documentation/redeeming-a-qr-code-voucher/making-idempotent-redemption-requests/introduction.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
